<script lang="ts">
  import type { RegConf } from "./RegisterConf.svelte";
  import type { TimeT } from "./Time.svelte";
  import type { Value as ValueT } from "./Value";

  import { createEventDispatcher, onMount, onDestroy } from "svelte";

  import RegisterConf from "./RegisterConf.svelte";
  import Time from "./Time.svelte";
  import Value from "./Value.svelte";

  import "chartjs-adapter-moment";
  import { Chart, registerables } from "chart.js";
  Chart.register(...registerables);
  import { GetValue } from "./Value";

  export let id: number;
  export let conf: RegConf | undefined;
  export let last: [TimeT, ValueT] | null;
  let detail = false;

  let chartRef: HTMLCanvasElement;
  let chart: Chart;
  onMount(() => {
    chart = new Chart(chartRef, {
      type: "line",
      data: {
        labels: [],
        datasets: [
          {
            borderColor: "green",
            data: [],
          },
        ],
      },
      options: {
        responsive: false,
        plugins: {
          legend: {
            display: false,
          },
        },
        scales: {
          x: {
            type: "time",
            ticks: {
              maxRotation: 0,
            },
          },
        },
      },
    });
  });
  onDestroy(() => {
    chart = null;
  });

  $: if (chart && last) {
    const unix =
      last[0].secs_since_epoch * 1000 + last[0].nanos_since_epoch / 1000000;

    if (unix != chart.data.labels[chart.data.labels.length - 1]) {
      if (chart.data.labels.length > 50) {
        chart.data.labels.shift();
        chart.data.datasets[0].data.shift();
      }
      chart.data.labels.push(unix);
      chart.data.datasets[0].data.push(GetValue(last[1]));

      // Only update if visible
      if (detail) chart.update();
    }
  }

  const dispatch = createEventDispatcher();
</script>

<div
  class="title"
  on:click={() => (detail = !detail)}
  on:keypress={() => (detail = !detail)}
  role="button"
  tabindex="0"
>
  Register {id}
  <div class="spacer" />
  <button on:click={() => dispatch("delete")}>Delete</button>
</div>

<div class="window" class:detail>
  <div class="conf">
    {#if conf}
      <RegisterConf {conf} on:value={(e) => dispatch("value", e.detail)} />
    {:else}
      This register is not configured, it had and will return 0
    {/if}
  </div>
  <span class="vertLine" />
  <div class="value" class:noValue={!last}>
    {#if last}
      <div class="lastValue">
        Last value <Value value={last[1]} />
        measured at <Time time={last[0]} />
      </div>
    {:else}
      <h3 class="noValueText">No value ...</h3>
    {/if}
    <canvas
      bind:this={chartRef}
      height="400"
      width="500"
      class:visible={!last}
    />
  </div>
</div>

<style lang="sass">
.title
	display: flex
	padding: 5px
	cursor: pointer
	align-items: center
	.spacer
		flex: 1
	button:
		margin: 0

.window
	height: 0
	overflow-y: hidden
	transition: height .6s cubic-bezier(0, 1, .7, 1)
	&.detail
		height: 500px

	display: flex
	align-items: center
	align-content: stretch
	.conf
		flex: 1

	.vertLine
		border-left: 1px dashed black
		height: 100%
		margin: 5px

	.value
		width: 500px	
		
		.visible
			display: none !important // To override display block

		.lastValue
			margin: 20px
		
		&.noValue
			position: relative
			height: 100%

			display: flex
			align-items: center
			justify-content: center

			.noValueText
				font-size: 1.5em
				color: silver
				z-index: 2
</style>
